var k2btools = k2btools || {};

k2btools.gridOverflowActionsClickCallback = function (e) {
  $('.K2BT_OverflowActionsContainer:visible').each(function (i, overflowActionsContainer) {
    if (k2btools.$(e.target).closest($(overflowActionsContainer).closest('.K2BT_OverflowActionsCollapsibleContainer')).length == 0) {
      $(overflowActionsContainer).hide();
      $(overflowActionsContainer).closest('td').find('.K2BT_OverflowActionsToggle, .K2BT_OverflowActionsToggleText').removeClass('K2BT_OverflowActionsToggleOpen');
    }
  });
};

function K2BGridOverflowActions(JQuery) {
  k2btools.$ = jQuery;

  this.GridControlName;
  this.ActionGroups;
  this._JQuery = JQuery;

  this.SetActionGroups = function (value) {
    this.ActionGroups = value;
  };

  this.GetActionGroups = function () {
    return this.ActionGroups;
  };

  var rwdVisibilityClasses = ['InvisibleInExtraSmallColumn', 'InvisibleInSmallColumn', 'InvisibleInMediumColumn', 'InvisibleInLargeColumn'];

  this.show = function () {
    this.refreshGridOverflowMenu();
    this.refreshActionGroups();
    k2btools.$('html').on('click', k2btools.gridOverflowActionsClickCallback);
    gx.fx.obs.addObserver('grid.onafterrender', this, this.refreshGridOverflowMenu, { single: false, unique: true });
  };

  this.destroy = function () {
    k2btools.$('html').off('click', k2btools.gridOverflowActionsClickCallback);
  };

  this.refreshActionGroups = function () {
    if (this.ActionGroups.length > 0) {
      var that = this;
      var gridTable = this._JQuery('.gx-grid')
        .children('table')
        .filter(function (index) {
          return that._JQuery(this).attr('id').toLowerCase() == that.GetGridTableName(that.GridControlName).toLowerCase();
        });

      if (gridTable.length)
        $(this.ActionGroups).each(function (i, group) {
          if ($(gridTable).find("th[data-k2btools-actiongroup='" + group.Class + "']").length == 0) {
            var rowCellClasses = $(gridTable)
              .find('TH.' + group.Class)
              .attr('class')
              .split(' ')
              .filter(function (item, i) {
                return item != '' && item.indexOf('gx') != 0 && item != group.Class && item != 'K2BT_InvisibleColumn';
              });

            var th = $("<th data-k2btools-actiongroup='" + group.Class + "'></th>");
            th.addClass(rowCellClasses);
            $(th).insertBefore($(gridTable).find('TH.' + group.Class)[0]);

            $(gridTable)
              .find('tbody TR')
              .each(function (i, row) {
                var overflowActionsContainer;
                if (!$(row).hasClass('K2BT_GridAggregationsRow') && $(row).find("[data-k2btools-actiongroup='" + group.Class + "']").length == 0) {
                  var rowCellClasses = $(row)
                    .find('TD.' + group.Class)
                    .attr('class')
                    .split(' ')
                    .filter(function (item, i) {
                      return item != '' && item.indexOf('gx') != 0 && item != group.Class && item != 'K2BT_InvisibleColumn';
                    });
                  var containsImage = $(row).find('TD.' + group.Class + ' img').length != 0;

                  var moreActionsCell = $('<td class="K2BT_OverflowActionsCollapsibleContainer" data-k2btools-actiongroup=\'' + group.Class + "'></td>");

                  // Add all row classes (except those used for RWD column visibility)
                  moreActionsCell.addClass(
                    rowCellClasses.filter(function (item, i) {
                      return rwdVisibilityClasses.indexOf(item) == -1;
                    }),
                  );

                  var moreActionsDiv = $('<div class="K2BT_OverflowActionsCellContainer" />');
                  moreActionsCell.append(moreActionsDiv);

                  var moreActionsToggle;
                  if (group.Caption != null && group.Caption != '' && group.Caption != undefined) {
                    moreActionsToggle = $('<span class="K2BT_OverflowActionsToggleText"><a>' + group.Caption + '</a></span>');
                  } else {
                    moreActionsToggle = $('<span class="K2BT_OverflowActionsToggle"><a></a></span>');
                  }
                  moreActionsDiv.append(moreActionsToggle);

                  overflowActionsContainer = $('<div class="K2BT_OverflowActionsContainer"></div>');

                  if (containsImage) overflowActionsContainer.addClass('K2BT_OverflowActionsContainerWithImage');

                  $(overflowActionsContainer).hide();
                  moreActionsDiv.append(overflowActionsContainer);

                  $(moreActionsCell).insertBefore($(row).find('.' + group.Class)[0]);

                  addToggleToMenu(overflowActionsContainer, moreActionsToggle);
                } else {
                  overflowActionsContainer = $(row).find("[data-k2btools-actiongroup='" + group.Class + "'] .K2BT_OverflowActionsContainer");
                }

                addRowActionsToMenu(row, group.Class, overflowActionsContainer, false);
              });
          }
        });
    }
  };

  this.refreshGridOverflowMenu = function () {
    var that = this;
    var gridTable = this._JQuery('.gx-grid')
      .children('table')
      .filter(function (index) {
        return that._JQuery(this).attr('id').toLowerCase() == that.GetGridTableName(that.GridControlName).toLowerCase();
      });

    if (gridTable.length && $(gridTable).find('.K2BT_ActionForOverflowMenu').length > 0) {
      // If the overflow menu has not been created yet, and overflow actions exist in the grid
      if ($(gridTable).find("th[data-k2btools-overflowmenuheader='true']").length == 0) {
        var rowCellClasses = $(gridTable)
          .find('TH.K2BT_ActionForOverflowMenu')
          .attr('class')
          .split(' ')
          .filter(function (item, i) {
            return item != '' && item.indexOf('gx') != 0 && item != 'K2BT_ActionForOverflowMenu';
          });

        var th = $("<th data-k2btools-overflowmenuheader='true'></th>");
        // Add all row classes (except those used for RWD column visibility)
        th.addClass(
          rowCellClasses.filter(function (item, i) {
            return rwdVisibilityClasses.indexOf(item) == -1;
          }),
        );

        // Add RWD column visibility classes that are not mentioned in the actions
        th.addClass(
          rwdVisibilityClasses.filter(function (item, i) {
            return rowCellClasses.indexOf(item) == -1;
          }),
        );
        $(gridTable).find('thead tr').append(th);
      }

      $(gridTable)
        .find('tbody TR')
        .each(function (i, row) {
          var overflowActionsContainer;
          if (!$(row).hasClass('K2BT_GridAggregationsRow') && $(row).find("[data-k2btools-overflowmenu='true']").length == 0) {
            var rowCellClasses = $(row)
              .find('TD.K2BT_ActionForOverflowMenu')
              .attr('class')
              .split(' ')
              .filter(function (item, i) {
                return item != '' && item.indexOf('gx') != 0 && item != 'K2BT_ActionForOverflowMenu';
              });
            var containsImage = $(row).find('TD.K2BT_ActionForOverflowMenu img').length != 0;

            var moreActionsCell = $('<td class="K2BT_OverflowActionsCollapsibleContainer" data-k2btools-overflowmenu=\'true\'></td>');

            // Add all row classes (except those used for RWD column visibility)
            moreActionsCell.addClass(
              rowCellClasses.filter(function (item, i) {
                return rwdVisibilityClasses.indexOf(item) == -1;
              }),
            );

            // Add RWD column visibility classes that are not mentioned in the actions
            moreActionsCell.addClass(
              rwdVisibilityClasses.filter(function (item, i) {
                return rowCellClasses.indexOf(item) == -1;
              }),
            );

            var moreActionsDiv = $('<div class="K2BT_OverflowActionsCellContainer" />');
            moreActionsCell.append(moreActionsDiv);

            var moreActionsToggle = $('<span class="K2BT_OverflowActionsToggle"><a></a></span>');
            moreActionsDiv.append(moreActionsToggle);

            overflowActionsContainer = $('<div class="K2BT_OverflowActionsContainer"></div>');

            if (containsImage) overflowActionsContainer.addClass('K2BT_OverflowActionsContainerWithImage');

            $(overflowActionsContainer).hide();
            moreActionsDiv.append(overflowActionsContainer);

            $(row).append(moreActionsCell);

            addToggleToMenu(overflowActionsContainer, moreActionsToggle);
          } else {
            overflowActionsContainer = $(row).find("[data-k2btools-overflowmenu='true'] .K2BT_OverflowActionsContainer");
          }

          addRowActionsToMenu(row, 'K2BT_ActionForOverflowMenu', overflowActionsContainer, true);
        });
    }
  };

  this.GetGridTableName = function (controlName) {
    return controlName + 'ContainerTbl';
  };

  function addRowActionsToMenu(row, className, overflowActionsContainer, addRWDClasses) {
    $(row)
      .find('.' + className)
      .each(function (i, cell) {
        var rowCellClasses = $(cell)
          .attr('class')
          .split(' ')
          .filter(function (item, i) {
            return item != '' && item.indexOf('gx') != 0 && item != className;
          });

        var id, txt, imgSrc;

        if ($(cell).find('img').length != 0) {
          var img = $(cell).find('img')[0];
          id = $(img).attr('id');
          imgSrc = $(img).attr('src');
          txt = $(img).attr('title');

          if (txt == undefined || txt == '') {
            txt = $(img).attr('data-original-title');
          }

          if (txt == undefined || txt == '') {
            txt = $(img).attr('alt');
          }
        } else {
          var sp = $(cell).find('span')[0];
          id = $(sp).attr('id');
          txt = $(sp).find('A').text();
        }

        if ($(overflowActionsContainer).find("[data-k2btools-originalId='" + id + "']").length == 0) {
          var actionSpan = $('<span class="K2BT_OverflowMenuAction"/>');

          if (addRWDClasses) {
            actionSpan.addClass(
              rwdVisibilityClasses.filter(function (item, i) {
                return rowCellClasses.indexOf(item) == -1;
              }),
            );
          }

          $(actionSpan).attr('data-k2btools-originalId', id).text(txt);

          if (imgSrc) $(actionSpan).css({ backgroundImage: "url('" + imgSrc + "')" });

          overflowActionsContainer.append(actionSpan);

          $(actionSpan).on('click', function (e) {
            if ($('#' + $(e.target).attr('data-k2btools-originalId')).is('SPAN')) {
              $('#' + $(e.target).attr('data-k2btools-originalId'))
                .find('A')[0]
                .click();
            } else {
              $('#' + $(e.target).attr('data-k2btools-originalId')).click();
            }
            $(e.target).closest('.K2BT_OverflowActionsContainer').hide();
          });
        }
      });
  }

  function addToggleToMenu(overflowActionsContainer, moreActionsToggle) {
    var elemWithOverflow = $(overflowActionsContainer)
      .parents()
      .filter(function () {
        return $(this).css('overflow-x') == 'scroll';
      })
      .first();

    $(moreActionsToggle).on('click', function () {
      $(overflowActionsContainer).toggle();

      if ($(overflowActionsContainer).is(':visible')) {
        $(moreActionsToggle).addClass('K2BT_OverflowActionsToggleOpen');

        if (elemWithOverflow.length > 0) {
          var height = $(overflowActionsContainer).outerHeight();
          var menuTop = $(overflowActionsContainer).offset().top;

          var scrollTop = $(elemWithOverflow).offset().top;
          var scrollHeight = $(elemWithOverflow).outerHeight();

          if (scrollTop + scrollHeight < menuTop + height) {
            $(elemWithOverflow).prop('data-k2bgridoverflowactions-originalpadding', $(elemWithOverflow).css('padding-bottom'));
            $(elemWithOverflow).css('padding-bottom', 20 + menuTop + height - (scrollTop + scrollHeight) + 'px');
          }
        }
      } else {
        $(moreActionsToggle).removeClass('K2BT_OverflowActionsToggleOpen');

        if (elemWithOverflow.length > 0) {
          $(elemWithOverflow).css('padding-bottom', $(elemWithOverflow).prop('data-k2bgridoverflowactions-originalpadding'));
        }
      }
    });
  }
  ///UserCodeRegionEnd: (do not remove this comment.):
}
